#!/usr/bin/perl
#
# yapw.cgi ( http://white.d51.net/yapw/yapw.cgi )
# $Id: yapw.cgi,v 1.127 2002/10/29 01:59:05 white Exp $

use EncodedTreeStore;
use strict;
no strict "refs";

#
# export-mode setting.
#
use vars qw(%mode %TemplateFILE
	    %exportlist %exportlist_r
	    $ExportDIR $ExportPageList);
if(@ARGV[0] =~ /^--export(.*?)/){
    shift;
    $mode{export} = 1;
    $ExportDIR = "EXPORT";
    $TemplateFILE{export} = "export.html";
}

# To Do:
#   * Auto embedding <base> element.
#
my(%cgi,%cookie,%TemplateCache,%cache,%Index,$commit_error);
my($root);
my($target);

use vars
    qw($Test %PATTERN
       $SIGN $ANONYSIGN
       $dataDIR 
       $DEFAULT_INDEX $ANCH_DEFAULT
       $URLencoding $ENABLE_SUEXEC 
       $KeepBraket $NonExistMark $TIMESTAMPQUERY_DISABLE
       $TemplateDIR
       $HTTPDIR $SERVER $CGIpath $baseURL $SELFNAME
       $enableElems $enableEmptyElems
       $enableInlineElems $enableInlineBlockElems 
       $enableBlockElems 
       $mustcloseBlockElems $uncloseableBlockElems
       );

default_config();
require 'yapw.conf';
require 'jcode.pl';
commit_config();

$root = new EncodedTreeStore($dataDIR);

# yapw.cgi is modal:
#  index, view, edit, set sign, add, write, atwrite and more

%cgi    = GETQuery();
%cookie = GETCookie();
if(defined $ENV{PATH_INFO}){
    $target = $ENV{PATH_INFO};
    $target =~s/^\///;
    $target = URLdecode($target);
    &jcode::convert(\$target,'euc');
    if($target =~ /^$/){
	undef $target;
    }
}

if($ENV{REQUEST_METHOD} eq "HEAD"){
    print httpHead($target);
    exit(0);
}

if(defined $ExportDIR){
    $URLencoding = "export";
    $ExportPageList = $ARGV[0];
    mode_export();
    exit(0);
}

if(defined $cgi{exec_setsign}){
    mode_setsign($cgi{setsign});
}

if(defined $cgi{exec_add}){
    $target = $cgi{add};
    mode_edit($target);
}

if(defined $cgi{order} || defined $cgi{list}){
    mode_index($target);
    exit(0);
}

if(not defined $target){
    $target = $DEFAULT_INDEX
	if(length($DEFAULT_INDEX) > 0 && existcheck($DEFAULT_INDEX));
}

if(defined $target){
    mode_edit($target)    if defined $cgi{edit} && (length($target) > 0);
    mode_write($target)   if defined $cgi{write};
    mode_delete($target)  if defined $cgi{delete};
    mode_atwrite($target) if defined $cgi{atwrite};
    mode_view($target);
}

# anything else
mode_index($target);
exit(0);

# each mode functions 
#   / call from yapw.cgi

sub mode_setsign{
    my($sign) = @_;
    $sign = $cgi{setsign};
    $cookie{yapwsign} = $sign;
    print setCookie("yapwsign",$sign);
}

sub mode_index{
    my($target) = @_;
    print httpHead();

    my(@Index) = readIndex($target,'array');
    map{ my $time =  $root->$_()->__timestamp("SOURCE");
	 $_ = { time     => $time,
		moddate  => time_str($time),
		URI      => "$CGIpath/".URLencode($_),
		name     => $_
		}
     } @Index;
    if($cgi{order} eq 'time'){
	@Index = sort { $b->{"time"} <=> $a->{"time"} } @Index;
    }
    my $content;
    foreach (@Index){
	$content .= 
	    sprintf(" +\\[%s]<a href='%s?time=%s'>%s</a>\n",
		    @{%$_}{qw(moddate URI time name)}  );
    }
    print makeView("",$content);
    exit(0);
}

sub mode_view{
    my($target) = @_;
    mode_redirect() if(! existcheck($target));
    print httpHead($target);
    print makeView($target);
    exit(0);
}

sub mode_edit{
    my($target) = @_;
    my($content);
    if(existcheck($target)){
	$content  = $root->$target()->SOURCE();
	$content  =~ s{\&}{\&amp;}g;
	$content  =~ s{\<}{\&lt;}g;
	$content  =~ s{\>}{\&gt;}g;
    }
    print httpHead($target);
    $content = resolveTemplate("edit",$content,$target,"edit");
    print resolveTemplate("base.html",$content,$target,"edit");
    exit(0);
}

sub mode_reedit{
    my($target) = @_;
    my $content  = $root->$target()->SOURCE();
    $content  =~ s{\&}{\&amp;}g;
    $content  =~ s{\<}{\&lt;}g;
    $content  =~ s{\>}{\&gt;}g;
    $commit_error = $cgi{text};
    $commit_error = quoteElemchar($commit_error);
    $commit_error =~ s{\n}{<br />\n}g;
    $content  = resolveTemplate("reedit",$content,$target,"edit");
    print httpHead($target);
    print resolveTemplate("base.html",$content,$target,"edit");
    exit(0);
}

sub mode_write{
    my($target) = @_;
    my($newsource) = $cgi{text};

    mode_reedit($target) if(conflictcheck($target));
    createboard($target) if(!existcheck($target));
    my $oldsource = $root->$target()->SOURCE();
    my $newsource = staticAlias($newsource);
    renew_page($target,$oldsource,$newsource);
    print redirect($target);
    exit(0);
}

sub mode_redirect{
    my($target) = @_;
    print redirect($target);
    exit(0);
}

sub mode_atwrite{
    my($target)    = @_;
    my($label)     = $cgi{atwrite};
    mode_redirect() if(! existcheck($target));
    $cgi{addsign} = 1;$cgi{adddate} = 1;
    my $oldsource = $root->$target()->SOURCE();
    my $newsource = atwrite_add($target,$oldsource,$label);
    $newsource = staticAlias($newsource);
    if($oldsource eq $newsource){
	print redirect($target);
	exit(0);
    }
    addRindex($target,$oldsource,$newsource);
    dropRindex($target,$oldsource,$newsource);
    $root->$target()->SOURCE($newsource."");

    mode_redirect($target);
    exit(0);
}

sub mode_delete{
    my($target) = @_;
    my $source = $root->$target()->SOURCE();
    if(is_empty($source)){
	$root->$target(undef);
 	print redirect();
 	print httpHead();
 	exit(0);
    }else{
 	print redirect($target);
    }
}

sub mode_export{
    open(ExportPageList,$ExportPageList);
    while(<ExportPageList>){
	    my($orig,$filename) = split(/[\s\t]+/,$_);
	    $exportlist{$orig} = $filename;
	    $exportlist_r{$filename} = $orig;
	}
    close(ExportPageList);
    my @Index = readIndex('array');
    foreach(@Index){
	my $output = $exportlist{$_} || $_;
	print "$_\n";
	my $result = makeExport($_);
	open(FILE,"> $ExportDIR/$output");
	print FILE $result;
	close(FILE);
    }
}

sub existcheck{
    my($target) = @_;
    my($filename,@temp);
    umask 0;
    return 0 if(ref($root->$target()) ne "TreeStore::Dir");
    return 0 if(ref($root->$target()->SOURCE()) eq "TreeStore::Undef");
    if(ref($root->$target()->RINDEX()) eq "TreeStore::Undef"){
	@temp = searchWord($target);
	$root->$target()->RINDEX(@temp);
    }
    return 1;
}

sub createboard{
    my($target) = @_;
    my($filename,@temp,$dir,$source,$rindex);
    umask 0;
    $root->$target()->SOURCE("");
    @temp = searchWord($target);
    return 1;
}

sub conflictcheck{
    my($target) = @_;
    return 1 if($root->$target()->__timestamp('SOURCE') != $cgi{timestamp});
    return 0;
}

sub redirect{
    my($target) = @_;
    my($filename,$timestamp);
    if($target eq ''){
	print "Location: $baseURL\n\n";
    }else{
	$filename  = URLencode($target);
	$timestamp = &TimestampQuery($target); 
	print "Location: $baseURL/$filename$timestamp\n\n";
    }
}

#
# Usual Fuctions for HTTP
#

sub setCookie{
    my($name,$value,@option) = @_;
    my($result,@day,@month);

    @day = ("Sun","Mon","Tue","Wed",
	    "Thu","Fri","Sat");
    @month = ("","Jan","Feb","Mar","Apr","May","Jun",
	      "Jul","Aug","Sep","Oct","Nov","Dec");
    my($sec,$min,$hour,$day,$month,$year,$wday,$yday,$dst)
        = gmtime(time + 365 * 24 * 60 * 60);
    $month++;$year += 1900;
    my $dateMes = 
        sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT"
                ,$day[$wday]
                ,$day,$month[$month],$year
                ,$hour,$min,$sec);
    $result .= "Set-cookie: $name=$value; path=$HTTPDIR; expires=$dateMes;\n";
    return $result;
}

sub URLencode{
#ARG = $plain | RETURNS = $encoded;
    return &{$URLencoding."encode"}(@_[0]);
}

sub URLdecode{
#ARG = $encoded | RETURNS = $plain;
    return &{$URLencoding."decode"}(@_[0]);
}

sub urlencode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    s/([^0-9a-zA-Z\-\_\.\!\~\*\'\(\)\/])/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub urldecode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}

# SimpleBase64 : 
# URL base64 encoding function for Opera support.
# [Opera6.0 can not treat correctry URL-encoded URL includes non-ascii charctor.]
#  (It's more better divide then into other module.)
# make tables from $base64table.
my(%b64table);
sub base64_init{
    local($_,@_);
    $b64table{pad} = [0,5,4,3,2,1];
    my $base64table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-';
    @_ = split(//,$base64table);
    my $i = 0;
    while(length($_ = shift(@_))){
	my($a,$b) = ($_,substr(unpack("B*",chr($i++)),2));
	die "SimpleBase64 : base table containts '$a' more than twice." if(defined $b64table{dec}{$a});
	$b64table{enc}{$b} = $a;
	$b64table{dec}{$a} = $b;
    }
    die "SimpleBase64 : base table length not enough $i" if($i != 64);
}
sub base64encode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    base64_init() if not defined %b64table;
    $_  = unpack("B*",$_);
    $_ .= "0" x $b64table{pad}->[length($_) % 6];
    $_  =~ s/(.{6})/$b64table{enc}{$1}/og;
    return $_;
}

sub base64decode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    my($pad,$length);
    base64_init() if not defined %b64table;
    $_  =~ s/(.)/$b64table{dec}{$1}/og;
    $pad    = length($_) % 8;
    $length = length($_) - $pad;
    $_  = substr($_,0,$length);
    $_  = pack("B*",$_);
    return $_;
}

sub exportencode{
    local($_) = @_;
    $_ = $exportlist{$_} || $_;
    return $_;
}

sub exportdecode{
    local($_) = @_;
    $_ = $exportlist_r{$_} || $_;
    return $_;
}

sub GETCookie{
#ARG = () | RETURNS = %cookie;
    my(%cookie,$line,$name,$value);
    foreach $line (split(/;\s*/,$ENV{HTTP_COOKIE})){
	($name,$value) = split(/=/,$line);
	$value = urldecode($value);
	$cookie{$name} = $value;
    }
    return %cookie;
}

sub GETQuery{
#ARG = () | RETURNS = %cgi_query;
    my(%cgi,$str,$i,$name,$value);

    if($ENV{REQUEST_METHOD} eq "GET"){
	$str = $ENV{QUERY_STRING};	
    }else{	
	read(STDIN,$str,$ENV{'CONTENT_LENGTH'});
    }

    if($str =~ /=/){
	foreach $i (split('&',$str)){
	    ($name,$value) = split('=',$i);
	    $value =~ tr/+/ /;
	    $value = urldecode($value);
	    &jcode::convert(*value,'euc');
	    $value =~ s/\015\012/\012/g;
	    $value =~ s/\015/\012/g;
	    $cgi{$name} = $value;
	}
    }else{
	$cgi{$str} = 1;
    }
    return %cgi;
    
}

sub joinpath{
    my($path);
    local($_);
    while(@_){
	$_ = shift(@_);
	last if($_ !~ /^\/*$/);
    }
    $path = $_;

    foreach(@_){
	next if($_ =~ /^\/*$/);
	if($path =~ /\/$/){
	    $path .= $_;
	}else{
	    $path .= "/$_";
	}
    }
    return $path;
}

sub httpHead{
    my($target) = @_;
    my $result .= "Content-type: text/html; charset=euc-jp\r\n";
    if($target ne '' && !$Test){
	my $time = Timestamp($target);
	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$stim) = gmtime($time);
	$wday = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$wday];
	$mon  = ("Jan","Feb","Mar","Apr","May","Jun"
		 ,"Jul","Aug","Sep","Oct","Nov","Dec")[$mon];
	$year += 1900;
	$result .=
	    sprintf("Last-Modified: %s, %02d %s %04d %02d:%02d:%02d GMT\r\n"
		    ,$wday,$day,$mon,$year,$hour,$min,$sec);
    }
    $result .= "\r\n";
    return $result;
}

sub getSign{
    $cookie{yapwsign} = $ANONYSIGN if($cookie{yapwsign} =~ /^\s*$/);
    return $cookie{yapwsign};
}

sub time_str{
    my($time) = @_;
    my(%time);
    @{%time}{qw(sec min hour mday mon
		year wday yday isdist)} = localtime($time);
    $time{year} += 1900;
    $time{mon}++;
    return sprintf("%04d/%02d/%02d %02d:%02d",
		   @{%time}{qw(year mon mday hour min)});
}

sub makeView{
    my($target,$content) = @_;
    my(%Index)   = readIndex();
    my(@Index)   = sort {length($a) <=> length($b);} keys %Index;

    $content||= $root->$target()->SOURCE();
    if(is_empty($content)){
	$content = &FORM_DELETE($target);
    }else{
	$content = preDynamicAlias($content);
	$content = elemFilter($content);
	$content = WikiLink($content,$target);
	$content = format_table($content);
	$content = format_list($content);
	$content = format_plain($content);
	$content = postDynamicAlias($content,$target);
    }
    return resolveTemplate("base.html",$content,$target);
}


sub makeExport{
    my($target) = @_;
    my $Template = readTemplate("export");
    
    my $content  = $root->$target()->SOURCE();
    
    $content = preDynamicAlias($content);
    $content = elemFilter($content);
    $content = WikiLink($content,$target);
    $content = format_table($content);
    $content = format_list($content);
    $content = format_plain($content);
    $content = postDynamicAlias($content,$target);

    return resolveTemplate($TemplateFILE{export},$content,$target);
}

sub readIndex{
#ARG = ($target,$mode) | RETURNS = (%Index);
# Index (List of Subject) is Filelist of SourceDIR
    my($target,@mode) = @_;
    my(%Index);
    my(%flag);
    local($_);
    foreach (@mode){
	$flag{'force'}  = 1 if($_ eq 'force');
	$flag{'return'} = 'hash'  if($_ eq 'hash');
	$flag{'return'} = 'array' if($_ eq 'array');
    }
    if(not defined $cache{Index} || defined $flag{'force'}){
	my @Index = $root->__();
	map {$Index{$_} = $_} @Index;
	delete $Index{"."};
	delete $Index{".."};
	$cache{Index} = \%Index;
    }
    my $Index = $cache{Index};
    if($flag{"return"} eq 'array'){
	return sort keys %$Index;
    }else{# return hash
	return %$Index;
    }
}

sub makeFindex{
#ARG = ($content) | RETURNS = (@FindexLIST);
    my($content) = @_;
    my(%result);

    $PATTERN{Index} = pattern_index();
    while($content =~ m{($PATTERN{Index})}og){
	$result{$1} = 1;
    }
    return sort keys %result;
}

sub compareFindex{
#ARG = (\@FindexLIST1,\@FindexLIST2) | RETURNS = @diffLIST;
# only returns entry defined in LIST1, but not defined in LIST2.
    my($NEWFindex,$OLDFindex) = @_;
    my($line,@diffLIST,%OLDFindex);
    local($_);
    foreach(@$OLDFindex){
	$OLDFindex{$_} = 1;
    }
    foreach $line(@$NEWFindex){
	push(@diffLIST,$line) if not defined $OLDFindex{$line};
    }
    return @diffLIST;
}

sub addRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex)   = makeFindex($oldsource);
    my(@newIndex)   = makeFindex($newsource);
    my(@targetLIST) = compareFindex(\@newIndex,\@oldIndex);
    foreach my $target (@targetLIST){
	my @rindex = $root->$target()->RINDEX();
	$root->$target()->RINDEX((@rindex,"$referer"));
    }
}

sub dropRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex)   = makeFindex($oldsource);
    my(@newIndex)   = makeFindex($newsource);
    my(@targetLIST) = compareFindex(\@oldIndex,\@newIndex);
    foreach my $target(@targetLIST){
	my(@content)= sort $root->$target()->RINDEX();
	my $rindex;
	chomp(@content);
	foreach my $line(@content){
	    $rindex .= "$line\n" unless ($line eq $referer);
	}
	$root->$target()->RINDEX($rindex);
    }
}

sub searchWord{
    my($key) = @_;
    my($qkey,@Index,@result,$content);
    local($_);
    @Index = readIndex('','array');
    $qkey = quotemeta($key);
    
    $PATTERN{Index} = pattern_index();
    foreach my $target (@Index){
	$content = $root->$target()->SOURCE();
	foreach(split(m{($PATTERN{Index}|$qkey)}o,$content)){
	    if($_ eq $key){
		push(@result,$target);
		last;
	    }
	}
    }
    return @result;
}

sub Timestamp{
    my($target) = @_;
    my($filename);
    return $root->$target()->__timestamp("SOURCE");
}

sub TimestampQuery{
    my($target)   = @_;
    if($TIMESTAMPQUERY_DISABLE != 1){
       return '?time='.Timestamp($target);
    }else{
       return;
    }
}

sub pattern_index{
    local($_);
    my(%Index,@Index,$result);
    %Index = (readIndex('','hash'));
    @Index = sort {length($b) <=> length($a)} keys %Index;
    return join('|', map {$_ = quotemeta($_)} @Index);
}

sub WikiLink{
    local($_);
    my($content,$subject) = @_;
    my(@buffer,$result);

    $PATTERN{Index} = pattern_index();
    foreach(split(m{(\\\\|<a.*?>.*?</a>|<pre.*?>.*?</pre>|\\$PATTERN{ATWRITE}|$PATTERN{ATWRITE}|\\$PATTERN{TABLE}|$PATTERN{TABLE}|</?(?:$enableElems)(?:\s.*?)?>|\\\[.*?\]|\[.*?\]|$PATTERN{URL})}so,$content)){
	if(/^\\\\/){
	    $_ = '\\';
	}elsif(m{^<a.*?>.*?</a>}){
	}elsif(m{^</?(?:$enableElems)(?:\s.*?)?>}o){
	    if(m{^(<pre.*?>)(.*?)(</pre>)}s){
		my($pre,$epre) = ($1,$3);
		$_ = $2;
		my(@save) = ($KeepBraket,$NonExistMark);
		$KeepBraket   = 1;
		$NonExistMark = '';
		s{<}{&lt;}g;
		s{>}{&gt;}g;
		s{(^|[^\\])(\[(.*?)\]|$PATTERN{Index})}{"$1".mklink($2)}eog;
		$_ = $pre.$_.$epre;
		($KeepBraket,$NonExistMark) = @save;
	    }
	}elsif(m{^\\}){
	}elsif(m{^$PATTERN{TABLE}}io){
	}elsif(m{^\[\@.*?\]}){
	    s/^\[\@(.*?(:(\[.*?\]|[^\[\]]*?)*)?)\]/&atwriteTool($1,$subject);/eg;
	}elsif(m{^https?://}){
	    $_ = "<a href='$_'>$_</a>";
	}else{
	    s{<}{&lt;}g;
	    s{>}{&gt;}g;
	    s{($PATTERN{TEXT})(\[(.*?)\]|$PATTERN{Index}|$PATTERN{WikiName})}{$1.mklink($2)}eog;
	}
	$result .= $_;
    }
    return $result;
}

sub mklink{
    my($name) = @_;
    my($face,$body,$label);
    my($prev,$post);
    my($path);
    if($name =~ /^\[(.*?)\]$/){
	if($KeepBraket){
	    ($prev,$post) = ('[' , ']');
	}
	$name = $1;
    }
    if($name =~ /.,./){
	($face,$body) = split(/,/,$name,2);
	if($body =~ /^$PATTERN{URL}/){
	    return "<a href='$body'>$face</a>";
	}elsif($body =~ /^$PATTERN{QUERY}/){
	    return "<a href='$ANCH_DEFAULT$body'>$face</a>";
	}elsif($body =~ /^$PATTERN{Index}/){
	    if($body =~ /\#/){
		($body,$label) = split(/\#/,$body,2);
		$label = "#".$label;
	    }
	    $path = $SELFNAME."/".URLencode($body);
	    return "<a href='".$path.TimestampQuery($body)."$label'>$face</a>";
	}elsif($body =~ /^\#/){
	    $path =  $SELFNAME."/".URLencode($target).TimestampQuery($target).$body;
	    return "<a href='$path'>$face</a>";
	}
    }
    $path =  $SELFNAME."/".URLencode($name);
    if(existcheck($name)){
	return "$prev<a href='".$path.TimestampQuery($name)."'>$name</a>$post";
    }elsif($NonExistMark){
	return "$prev$name$post<a href='$path?edit'>$NonExistMark</a>";
    }else{
	return "$prev$name$post";
    }
}

sub renew_page{
    my($target,$oldsource,$newsource) = @_;
    if($oldsource eq $newsource){
	return;
    }
    addRindex($target,$oldsource,$newsource);
    dropRindex($target,$oldsource,$newsource);
    $root->$target()->SOURCE("$newsource");
}

sub readTemplate{
#ARG = $templateName | RETURNS $Template;
#  %Template cashes Template files.
    my($label) = @_;
    my(%Template);
    if(exists $Template{$label}){
	return $Template{$label};
    }else{
	return ($TemplateCache{$label} ||= readfile("$TemplateDIR/$label"));
    }
}

sub readfile{
    my($path) = @_;
    my($result);
    open(FILE,"< $path");
    if(wantarray){
	my @result = <FILE>;
	close(FILE);
	return @result;
    }else{
	while(<FILE>){
	    $result .= $_;
	}
	close(FILE);
	return $result;
    }
}

sub quoteElemchar{
    my($src) = @_;
    $src =~ s{<}{&lt;}g;
    $src =~ s{>}{&gt;}g;
    return $src;
}

sub elemFilter{
    my($src) = @_;
    $src =~ s{<(?!\/?(?:$enableElems)[^<]*?>)}{&lt;}iog;
    $src = join('',map{s/>/&gt;/g unless /^</;$_;} split(/(<.*?>)/,$src));
    return $src;
}

sub staticAlias{
#ARG = ($source) | RETURNS = ($source);
    my($source) = @_;
    my($result);
    foreach(split(m{(\\$PATTERN{ATWRITE}|$PATTERN{ATWRITE})}io,$source)){
	if(!/^$PATTERN{ATWRITE}/io){
	    s/(^|[^\\])\%sign\%/"$1".&doSign();/emg;
	}
	$result .= $_;
    }
    return $result;
}

sub preDynamicAlias{
    my($source) = @_;
    $source =~ s/(^|[^\\])\%sign\%/"$1".&getSign();/eg;
    $source =~ s/(^|[^\\])\%YaPWsource\%/"$1".&showCGISource();/eg;

    return $source;
}

sub postDynamicAlias{
    my($source,$subject) = @_;

    $source =~ s/\\\[(.*?)\]/[$1]/g;

    return $source;
}

sub atwrite_add{
    my($target,$source,$label) = @_;

    mode_redirect($target) unless($source =~ /(?:^|[^\\])\[(\@+)$label(?::((\[.*?\]|.*?)+))?\]/s);
    my $before = $`;
    my $tool   = $&;
    my $after  = $';$';
    my($mode);
    if(length($1) >= 2){
	$mode = 'next';
    }else{
	$mode = 'previous';
    }
    my $format = $2 || '[]';
    my(@format) = split(/(\(.*?\)|<.*?>|\[.*?\]|\\\\|\n|\\n)/s,$format);
    my $addsource = '';
    my $verify    = '';
    my $count = 0;
    foreach(@format){
	if(/^\s*$/){
	    $addsource .= $_;
	    next;
	}elsif(/^<.*?>$/){
	    $addsource .= $_;
	}elsif(/^\((.*?)\)$/){
	    next;
	}elsif(/\[\%date\%\]/){
	    my($date_str) = getDate();
	    $addsource .= "($date_str)";
	    $verify    .= "($date_str)";
	}elsif(/^\[.*?\]/){
	    $count++;
	    $addsource .= $cgi{"at$count"};
	    $verify    .= $cgi{"at$count"};
	    next;
	}elsif(/^\\\\$/){
	    $addsource .= "\\";
	}elsif(/^\\n$/){
	    $addsource .= "\n";
	}else{
	    $addsource .= $_;
	}
    }
    if($count == 0){
	$count++;
	$addsource .= $cgi{"at$count"};
	$verify    .= $cgi{"at$count"};
    }
    mode_redirect($target) if($verify =~ /^\s*$/);
    if($mode eq 'previous'){
	$source = $before."\n".$addsource.$tool.$after;
    }else{
        $source = $before.$tool."\n".$addsource.$after;
    }
    return $source;
}

sub atwriteTool{
    my($label,$subject) = @_;
    my($form,$option,$count,$format,@format,$content,$path);
    $label  =~ /^\@*(.*?)(?::(.*))?$/s;
    $label  = $1;
    $format = $2 || '[]';

    @format = split(/(\(.*?\)|<.*?>|\[.*?\]|\\n|\n)/,$format);
    $path = $0."/".URLencode($subject);
    $form .= "<form action='$path' method='get'>";
    $count = 0;
    foreach(@format){
	if(/^\n$/){
	    $form .= "<br />\n";
	}elsif(/^\\n/){
	}elsif(/^\s*$/){
	}elsif(/\[\%date\%\]/){
	}elsif(/^\[(.*?)(?:[\/](.*?))?\]/){
	    $count++;
	    my $name = "at$count";
	    $option  = $1 || "size='50'";
	    $content = $2 || "";
	    if($option =~ /(cols|rows)/i){
		$form .= "<textarea name='$name' $option>$content</textarea>";
	    }else{
		$form .= "<input type='text' name='$name' $option value='$content' />";
	    }
	    next;
	}elsif(/^<.*?>$/){
	    $form .= $_;
	}elsif(/^\((.*?)\)$/){
	    $form .= $1;
	}else{
	    # anything else
	    $form .= $_;
	}
    }
    if($count == 0){
	$count++;
	$option = "size='50'";
	$form  .= "<input type='text' name='at$count' $option />";
    }
    $form .= "<input type='hidden' name='atwrite' value='$label'>";
    $form .= "<input type='submit' value='' />";
    $form .= "</form>";

    return $form;
}

sub resolveTemplate{
    my($TemplateName,$content,$subject,$mode) = @_;
    local($_) = resolveTemplate_sub($TemplateName,$content,$subject,$mode);
    s{(^|[^\\])\%(.*?)\%}{(${$2})?"$1${$2}":"$1\%$2\%";}eg;
    s{(^|[^\\])\%findex\%}{$1.&showFindex($content,$subject);}se if($mode ne "edit");
    s/\\\%/\%/mg if($mode ne "edit");
    return $_;
}

sub resolveTemplate_sub{
    my($TemplateName,$content,$subject,$mode) = @_;
    local($_) = readTemplate($TemplateName);

    s/(^|[^\\])\%navigation\%/$1.&resolveTemplate_sub("navigation",$content,$subject)/eg;
    s/(^|[^\\])\%sign\%/"$1".&getSign();/eg;
    s{(^|[^\\])\%content\%}{$1$content}g;
    s{(^|[^\\])\%baseURL\%}{$1$baseURL}g;
    s{(^|[^\\])\%cgiURL\%}{$1$CGIpath}g;
    s{(^|[^\\])\%pathinfo\%}{$1.&URLencode($subject)}eg;
    s{(^|[^\\])\%rindex\%}{$1.&showRindex($subject);}eg;
    s{(^|[^\\])\%timestamp\%}{$1.&Timestamp($subject)}eg;
    s{(^|[^\\])\%subject\%}{$1.$subject || "INDEX::"}eg;
    s{(^|[^\\])\%commit_error\%}{$1$commit_error}g;
    return $_;
}


sub doSign{
#ARG = () | RETURNS = ($date_and_sign);
    my($SIGN,$sign,$date);
    $sign             = getSign()  if(defined $cgi{addsign});
    if(defined $cgi{adddate}){
	my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	    =localtime(time);$mon++;$year += 1900;
	$date = sprintf("%04d/%02d/%02d %02d:%02d"
			,$year,$mon,$day,$hour,$min);
    }
    $SIGN = "<span class='signature'>--$date $sign<\/span>" if($sign || $date);
    return $SIGN;
}

sub getDate{
    my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	=localtime(time);$mon++;$year += 1900;
    return sprintf("%04d/%02d/%02d %02d:%02d",$year,$mon,$day,$hour,$min);
}

sub showCGISource{
#ARG = () | RETURNS = ($content_of_'this'_script);
    my(@source,$source);
    open(THIS,"$ENV{SCRIPT_FILENAME}");
    @source = <THIS>;
    close(THIS);
    $source = join('',@source);
    $source =~ s{<}{&lt;}g;
    $source =~ s{>}{&gt;}g;
    return "<pre>\n".$source."</pre>\n";
}

sub showRindex{
# prepare Rindex
    my($target) = @_;
    my(@result);
    my @Rindex   = sort $root->$target()->RINDEX();
    my $Rindex .= "\n";
    foreach my $line(@Rindex){
	next if($line =~ /^\s*$/);
	next if($line eq $target);
	my $filename  = URLencode($line);
	my $timestamp = Timestamp($line);
	push(@result,"<a href='$CGIpath/$filename?time=$timestamp'>$line</a>\n");
    }
    return join(" | ",@result);
}

sub showFindex{
    my($content,$subject) = @_;
    my(%Findex,@Findex);
    while($content =~ m{(<a href=.*?>(.*?)</a>)}ig){
	my($body,$name) = ($1,$2);
	next if($name eq $NonExistMark);
	next if($name =~ /^<img/);
	next if($name eq $subject);
	$Findex{$name} = $body;
    }
    map{push(@Findex,$Findex{$_})}(sort keys %Findex);
    return join(" | ",@Findex);
}

sub is_empty{
    my($text) = @_;
    if($text =~ /^\s*$/){
	return 1;
    }else{
	return 0;
    }
}

sub FORM_DELETE{
    my($subject) = @_;
    return &resolveTemplate("delete",'',$subject);
}

## Test codes for doc-formatting plugins
sub plug_test{
    my $doc;
    while(<>){
	$doc .= $_;
    }

    $doc = plug_table($doc);
    $doc = plug_list($doc);

    print $doc;
}

sub format_list{
    my($text) = @_;
    my $result;

    foreach(split(m{(<pre>.*?</pre>)}s,$text)){
	if(/^<pre>/){
	    $result .= $_;
	}else{
	    $result .= format_list_core($_);
	}
    }
    return $result;
}

sub format_list_unshift_level{
    my($indent,$level,$mode) = @_;
    my($result);
    while(@$level){
	last unless ($indent < $$level[0]);
	$result .= ' ' x ($$level[0] - 1) . "</li></ul>\n" if($$mode);
	shift(@$level);
    }
    $mode = 0 if($$level[0] eq '');
    return $result;
}

sub format_list_core{
    my($text) = @_;

    my(@lines);
    foreach(split(/\n/,$text)){
	/^(\s*)(.*?)$/;
	my $indent    = $1;
	my $level     = length($1);
	my $content   = $2;
	my $list_mark;
	if($content =~ s/^\+//){
	    $list_mark = 1;
	    $level++;
	    $content   = "<li>".$content;
	}else{
	    $list_mark = 0;
	}
	push(@lines,{indent => $indent,  level => $level ,
		     content => $content,list_mark => $list_mark});
    }
    
    my($result);
    my(@level);
    my($mode) = 0;
    while(@lines){
	$_ = shift(@lines);
#	$result.= "$_->{level}:";
	if($_->{level} < $level[0]){
	    $result .= format_list_unshift_level($_->{level},\@level,\$mode);
	    if($mode && $_->{list_mark}){
		$result .= '</li>';
	    }
	}elsif($_->{level} == $level[0]){
	    if($mode && $_->{list_mark}){
		$result .= '</li>';
	    }
	}else{# if($indent > $level[0]);
	    if($_->{list_mark}){
		unshift(@level,$_->{level});
		$result .= ' ' x ($_->{level} - 1) . "<ul>\n";
	    }
	}
	$result .= $_->{indent}.$_->{content}."\n";
	$mode |= $_->{list_mark};

	if($level[0] eq ''){
	    $mode = 0;
	}
    }
    $result .= format_list_unshift_level(0,\@level,\$mode);
    $result =~ s{\n(\s*)</li>}{</li>\n$1}g;
    return $result;
}

sub format_table{
    my($text) = @_;
    my $result;
    foreach(split(m{(<pre>.*?</pre>)}s,$text)){
	if(/^<pre>/){
	    $result .= $_;
	}else{
	    $result .= format_table_core($_);
	}
    }
    return $result;
}

sub format_table_core{
    my($text) = @_;
    my $is_table = 0;
    my($table,$result,$table_opt);
    foreach(split(m{\n}s,$text)){
	print STDERR "[$_]\n";
	if(/^\|\|(.*?)\|\|/s){
	    $is_table = 1;
	    $table_opt = $1;
	    next;
	}elsif(s/^\|//s){
	    $is_table = 1;
	    $table .= "$_\n";
	    next;
	}else{
	    if($table){
		$is_table = 0;
		$result .=  format_table_maketable($table_opt,$table);
		$table = ""; $table_opt = "";
	    }
	    $result .= "$_\n";
	}
    }
    $result .= format_table_maketable($table_opt,$table) if($table);
    return $result;
}

sub format_table_maketable{
    my($table_opt,$text) = @_;
    my($result);
    $table_opt = " ".$table_opt if($table_opt);
    foreach(split("\n",$text)){
	my($line,@line);
	@line = split(/\|/,$_);
	while(@line){
	    $_ = shift(@line);
	    while(s/\\$//){
		$_ .=  "|". shift(@line);
	    }
	    my($colspan);
	    if(s/^(\s*)(~+)/$1/){
		$colspan = " colspan='".(length($2) + 1)."'";
	    }
	    $line .= "<td$colspan>$_</td>";
	}
	$result .= "<tr>$line</tr>\n" if($line);
    }
    $result = "<table$table_opt>\n$result</table>\n" if($result);
    return $result;
}

sub format_plain{
    local($_) = @_;
    my($result,$elem,@paragraph,@temp,@elem);

    @paragraph = split(/(<\/?(?:$enableBlockElems|$enableInlineBlockElems)(?: .*?)?>)/soi,$_);
    
    while(@paragraph){
	$_ = shift(@paragraph);
	if(m{<($enableBlockElems)( .*?)?>}oi){
	    my($elem) = $1;
	    push(@temp,$_);
	    while(@paragraph){
		$_ = shift(@paragraph);
		push(@temp,$_);
		if(m{^<\/($enableBlockElems)( .*?)?>}oi){
		    last;
		}
	    }
	}else{
	    my $par = $_;
	    while(@paragraph){
		$_ = shift(@paragraph);
		if(m{<($enableBlockElems)( .*?)?>}oi){
		    unshift(@paragraph,$_);
		    last;
		}
		$par .= $_;
	    }
	    push(@temp,split(/(?:\s*?\n){2,}/s,$par));
	}
	 
    } @paragraph = @temp;

    while(@paragraph){
	$_ = shift(@paragraph);
	if(m{<\/($enableBlockElems)>}oi){
	    while(@elem && $elem[0] ne $1){
		shift(@elem);
	    }
	    shift(@elem);
	}elsif(m{^<($enableBlockElems)( .*?)?>}oi){
	    unshift(@elem,$1);
	}elsif(!@elem){
	    $_ = "<p>$_</p>\n";
	    s{(?:$PATTERN{CR}){2,}}{</p>\n<p>}smg;
	}
	s{\n}{<br />\n}mg if($elem[0] ne 'pre');
	s{<(/?)($enableBlockElems|$enableInlineBlockElems)>(\n*)<br />}{<$1$2>$3}g;
	s{<br />(\n*)<(/?)($enableBlockElems|$enableInlineBlockElems)>}{$1<$2$3>}g;
	s/^\s*<br \/>$//mg;
	s{</tr><br />}{</tr>}mg;
	s{<p></p>}{\n}g;
	$result .= $_;
    }
    return $result;
}

sub commit_config{
    $enableBlockElems = "$uncloseableBlockElems|$mustcloseBlockElems";
    $enableElems      = "$enableInlineElems|$enableBlockElems|$enableEmptyElems";
}

sub default_config{
## default configurations
    $Test = 1;

# localhost configuration
    my $baseDIR      = ($ENV{SCRIPT_FILENAME} =~ /^(.*)\/.*?$/)[0];
    $dataDIR      = "./DATA";
    $TemplateDIR  = "./Template";
    $SELFNAME     = ($ENV{SCRIPT_FILENAME} =~ /^.*\/(.*?)$/)[0];
    $ANCH_DEFAULT = "";

# http configuration
    $HTTPDIR      = ($ENV{SCRIPT_NAME} =~ /^(.*)\/.*?$/)[0];
    $CGIpath      = $ENV{SCRIPT_NAME};
    $baseURL    ||= "http://$ENV{SERVER_NAME}$ENV{SCRIPT_NAME}";
    $ENABLE_SUEXEC  = 'no';

    $URLencoding  = 'url'; # url / base64
  
# Displaying configuration
    $KeepBraket = 0;
    $NonExistMark = '?';

# html-elements enable list
    $enableInlineElems =
	"a|em|strong|cite|dfn|code|samp|kbd|var|abbr|acronym|".
	    "sub|sup|pre|address|tt|i|b|s|big|small|span|del|ins";
    $uncloseableBlockElems  = "blockquote|p|pre|dl|ul|h2|h3|h4";
    $mustcloseBlockElems    = "dt|dd|li|div";
    $enableInlineBlockElems = "del|ins";
    $enableBlockElems = "$uncloseableBlockElems|$mustcloseBlockElems|$enableInlineBlockElems";
    $enableEmptyElems = "img|br|hr";
    $enableElems      = "$enableInlineElems|$enableBlockElems|$enableEmptyElems";
    
# user-sign&auth
    $ANONYSIGN = "somebody";
    $SIGN      = "";

# matching patterns
    $PATTERN{URL}    = '(?:|https?|ftp)://[\w;/?:@&=\+\$\.,\-!~\*\%\'\(\)\#]+';
    $PATTERN{QUERY}  = '\?.*?';
    $PATTERN{ATWRITE}= '\[\@(?:\[.*?\]|[^\[\]]*?)+\]';
    $PATTERN{TABLE}  = '\[\#(?:\[.*?\]|[^\[\]]*?)+\]';
    $PATTERN{WikiName}= '(?:[A-Z]+[a-z]+){2,}';
    $PATTERN{CR}     = '\r\n|\n|\r';
    $PATTERN{TEXT}   = '(?:^|\s|\G)(?:[\x00-\x7f]|[\x80-\xff][\x80-\xff])*?'
}

